#include <SM.h>
#include <Wire.h>  // Comes with Arduino IDE
#include <LiquidCrystal_I2C.h>

SM CLAVIER(&etape1);//create statemchine with initial head and body state functions
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);

byte specialCHAR[8] = {
  B10001,
  B10001,
  B11111,
  B01110,
  B01110,
  B00000,
  B00000,
};
int code1 = 4;
int code2 = 3;
int code3 = 7;
int code4 = 1;

byte degree = 0xDF;
bool COMBI4;
bool COMBI3;
bool COMBI7;
bool COMBI1;
bool COMBID;

bool COMBI2;
bool COMBI5;
bool COMBI6;
bool COMBI8;
bool COMBI9;
bool COMBIA;
bool COMBIB;
bool COMBIC;
bool COMBISTAR;
bool COMBI0;
bool COMBIDIESE;

int VALEURCOMBI;
bool pin2;
bool pin4;
bool pin7;
bool pin8;
bool pin13;
int etat = 0;



void setup() {
  lcd.begin(20, 4);
  lcd.setCursor(0, 0);
  lcd.write("    KEYPAD LOCKER   ");
  lcd.createChar(2, specialCHAR);//Give a number to your special char
  lcd.setCursor(19, 0);
  lcd.write(byte(2));//Display the number of the SPECIAL CHAR
  lcd.setCursor(0, 0);
  lcd.write(byte(2));//Display the number of the SPECIAL CHAR
  pinMode(2, INPUT);//A
  pinMode(4, INPUT);//B
  pinMode(7, INPUT);//C
  pinMode(8, INPUT);//D
  pinMode(13, INPUT);//DA
  pinMode(3, OUTPUT);//D3 UNLOCK
  pinMode(5, OUTPUT);//D5 ERROR
}

void loop() {
  EXEC(CLAVIER);//run statemachine
  pin2 = digitalRead(2);
  pin4 = digitalRead(4);
  pin7 = digitalRead(7);
  pin8 = digitalRead(8);
  pin13 = digitalRead(13);
  COMBI4 = !pin2 && !pin4 && pin7 && !pin8;
  if (COMBI4 == 1) {
    VALEURCOMBI = 4;
  }
  COMBI3 = !pin2 && pin4 && !pin7 && !pin8;
  if (COMBI3 == 1) {
    VALEURCOMBI = 3;
  }
  COMBI7 = !pin2 && !pin4 && !pin7 && pin8;
  if (COMBI7 == 1) {
    VALEURCOMBI = 7;

  }
  COMBI1 = !pin2 && !pin4 && !pin7 && !pin8 && pin13;
  if (COMBI1 == 1) {
    VALEURCOMBI = 1;

  }
  COMBID = pin2 && pin4 && pin7 && pin8;
  if (COMBID == 1) {
    VALEURCOMBI = 13;

  }

  COMBI2 = pin2 && !pin4 && !pin7 && !pin8;
  if (COMBI2 == 1) {
    VALEURCOMBI = 2;

  }
  COMBI5 = pin2 && !pin4 && pin7 && !pin8;
  if (COMBI5 == 1) {
    VALEURCOMBI = 5;

  }
  COMBI6 = !pin2 && pin4 && pin7 && !pin8;
  if (COMBI6 == 1) {
    VALEURCOMBI = 6;

  }
  COMBI8 = pin2 && !pin4 && !pin7 && pin8;
  if (COMBI8 == 1) {
    VALEURCOMBI = 8;

  }
  COMBI9 = !pin2 && pin4 && !pin7 && pin8;
  if (COMBI9 == 1) {
    VALEURCOMBI = 9;

  }
  COMBIA = pin2 && pin4 && !pin7 && !pin8;
  if (COMBIA == 1) {
    VALEURCOMBI = 10;

  }
  COMBIB = pin2 && pin4 && pin7 && !pin8;
  if (COMBIB == 1) {
    VALEURCOMBI = 11;

  }
  COMBIC = pin2 && pin4 && !pin7 && pin8;
  if (COMBIC == 1) {
    VALEURCOMBI = 12;

  }
  COMBISTAR = !pin2 && !pin4 && pin7 && pin8;
  if (COMBISTAR == 1) {
    VALEURCOMBI = 14;

  }
  COMBI0 = pin2 && !pin4 && pin7 && pin8;
  if (COMBI0 == 1) {
    VALEURCOMBI = 16;

  }
  COMBIDIESE = !pin2 && pin4 && pin7 && pin8;
  if ((COMBIDIESE == 1)) {
    VALEURCOMBI = 15;
  }
  /*if (CLAVIER.Finished) {
    EXEC(CLAVIER);
    CLAVIER.Set(etape1);
    }*/
  if (VALEURCOMBI <= 9) {
    lcd.setCursor(10, 2);
    lcd.write(" ");
    lcd.setCursor(11, 2);
    lcd.print(String (VALEURCOMBI));
  }
  if (VALEURCOMBI > 9) {
    lcd.setCursor(10, 2);
    lcd.print(String (VALEURCOMBI));
  }

}

State etape1() {
  digitalWrite(3, LOW);
  lcd.setCursor(10, 3);
  lcd.write("etape 1");
  lcd.setCursor(0, 2);
  lcd.write("WAITING");
  if (RE(pin13, etat ) == 1) {
    CLAVIER.Set(etape2);
  }
}

State etape2() {
  digitalWrite(3, LOW);
  lcd.setCursor(10, 3);
  lcd.write("etape 2");
  if (VALEURCOMBI == code1) {
    CLAVIER.Set(etape3);
  }
}

State etape3() {
  digitalWrite(3, LOW);
  lcd.setCursor(10, 3);
  lcd.write("etape 3");
  if (RE(pin13, etat ) == 1) {
    CLAVIER.Set(etape4);
  }
}
State etape4() {
  digitalWrite(3, LOW);
  lcd.setCursor(10, 3);
  lcd.write("etape 4");
  if (VALEURCOMBI == code2) {
    CLAVIER.Set(etape5);
  }
  if ((VALEURCOMBI > code2) || (VALEURCOMBI < code2)) {
    CLAVIER.Set(etape10);
  }
  /*
    if (VALEURCOMBI < code2) {
    CLAVIER.Set(etape10);
    }*/
}
State etape5() {
  digitalWrite(3, LOW);
  lcd.setCursor(10, 3);
  lcd.write("etape 5");
  if (RE(pin13, etat ) == 1) {
    CLAVIER.Set(etape6);
  }
}

State etape6() {
  digitalWrite(3, LOW);
  lcd.setCursor(10, 3);
  lcd.write("etape 6");
  if (VALEURCOMBI == code3) {
    CLAVIER.Set(etape7);
  }
  if ((VALEURCOMBI > code3) || (VALEURCOMBI < code3)) {
    CLAVIER.Set(etape10);
  }
  /*
    if (VALEURCOMBI < code3) {
    CLAVIER.Set(etape10);
    }*/
}
State etape7() {
  digitalWrite(3, LOW);
  lcd.setCursor(10, 3);
  lcd.write("etape 7");
  if (RE(pin13, etat ) == 1) {
    CLAVIER.Set(etape8);
  }
}

State etape8() {
  digitalWrite(3, LOW);
  lcd.setCursor(10, 3);
  lcd.write("etape 8");
  if (VALEURCOMBI == code4) {
    CLAVIER.Set(etape9);
  }
  if ((VALEURCOMBI > code4) || (VALEURCOMBI < code4)) {
    CLAVIER.Set(etape10);
  }

}

State etape9() {
  lcd.setCursor(10, 3);
  lcd.write("etape 9");
  lcd.setCursor(0, 2);
  lcd.write("UNLOCK ");
  digitalWrite(3, HIGH);

  if (VALEURCOMBI == 13) {
    CLAVIER.Set(etape1);
  }
}

State etape10() {
  lcd.setCursor(10, 3);
  lcd.write("etape10");
  lcd.setCursor(0, 2);
  lcd.write("ERROR  ");
  digitalWrite(5, HIGH);
  delay(500);
  digitalWrite(5, LOW);
  delay(500);
  digitalWrite(5, HIGH);
  delay(500);
  digitalWrite(5, LOW);
  if (CLAVIER.Timeout(2000)) {
    CLAVIER.Set(etape1);
  }
}


